OSDN Git Service

* config/i386/k6.md (k6_alux): Use the 'mode' attribute instead of
[pf3gnuchains/gcc-fork.git] / maintainer-scripts / gcc_release
1 #! /bin/sh
2
3 ########################################################################
4 #
5 # File:   gcc_release
6 # Author: Jeffrey Law, Bernd Schmidt, Mark Mitchell
7 # Date:   2001-05-25
8 #
9 # Contents:
10 #   Script to create a GCC release.
11 #
12 # Copyright (c) 2001, 2002 Free Software Foundation.
13 #
14 # This file is part of GCC.
15 #
16 # GCC is free software; you can redistribute it and/or modify
17 # it under the terms of the GNU General Public License as published by
18 # the Free Software Foundation; either version 2, or (at your option)
19 # any later version.
20 #
21 # GCC is distributed in the hope that it will be useful,
22 # but WITHOUT ANY WARRANTY; without even the implied warranty of
23 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
24 # GNU General Public License for more details.
25 #
26 # You should have received a copy of the GNU General Public License
27 # along with GCC; see the file COPYING.  If not, write to
28 # the Free Software Foundation, 59 Temple Place - Suite 330,
29 # Boston, MA 02111-1307, USA.
30 #
31 ########################################################################
32
33 ########################################################################
34 # Notes
35 ########################################################################
36
37 # Here is an example usage of this script, to create a GCC 3.0.2
38 # prerelease:
39 #
40 #   gcc_release -r 3.0.2
41 #
42 # This script will automatically use the head of the release branch
43 # to generate the release.
44
45 ########################################################################
46 # Functions
47 ########################################################################
48
49 # Issue the error message given by $1 and exit with a non-zero
50 # exit code.
51
52 error() {
53     echo "gcc_release: error: $1"
54     exit 1
55 }
56
57 # Issue the informational message given by $1.
58
59 inform() {
60     echo "gcc_release: $1"
61 }
62
63 # Issue a usage message explaining how to use this script.
64
65 usage() {
66 cat <<EOF
67 gcc_release -r release [-f] [further options]
68 gcc_release -s name:cvsbranch [further options]
69
70 Options:
71
72   -r release           Version of the form X.Y or X.Y.Z.
73   -s name:cvsbranch    Create a snapshot, not a real release.
74
75   -d destination       Local working directory where we will build the release
76                        (default=${HOME}).
77   -f                   Create a final release (and update ChangeLogs,...).
78   -l                   Indicate that we are running on gcc.gnu.org.
79   -p previous-tarball  Location of a previous tarball (to generate diff files).
80   -t tag               Tag to mark the release in CVS.
81   -u username          Username for upload operations.
82 EOF
83     exit 1
84 }
85
86 # Change to the directory given by $1.
87
88 changedir() {
89   cd $1 || \
90     error "Could not change directory to $1"
91 }
92
93 # Each of the arguments is a directory name, relative to the top
94 # of the source tree.  Return another name for that directory, relative
95 # to the working directory.
96
97 adjust_dirs() {
98   for x in $@; do
99     echo `basename ${SOURCE_DIRECTORY}`/$x
100   done
101 }
102
103 # Build the source tree that will be the basis for the release
104 # in ${WORKING_DIRECTORY}/gcc-${RELEASE}.
105
106 build_sources() {
107   # If the WORKING_DIRECTORY already exists, do not risk destroying it.
108   if [ -r ${WORKING_DIRECTORY} ]; then
109     error "\`${WORKING_DIRECTORY}' already exists"
110   fi
111   # Create the WORKING_DIRECTORY.
112   mkdir "${WORKING_DIRECTORY}" \
113     || error "Could not create \`${WORKING_DIRECTORY}'"
114   changedir "${WORKING_DIRECTORY}"
115
116   # If this is a final release, make sure that the ChangeLogs
117   # and version strings are updated.
118   if [ ${FINAL} -ne 0 ]; then
119     inform "Updating ChangeLogs and version files"
120
121     ${CVS} co -d "`basename ${SOURCE_DIRECTORY}`" \
122            -r ${CVSBRANCH} gcc || \
123            error "Could not check out release sources"
124     for x in `find ${SOURCE_DIRECTORY} -name ChangeLog`; do
125       # Update this ChangeLog file only if it does not yet contain the
126       # entry we are going to add.  (This is a safety net for repeated
127       # runs of this script for the same release.)
128       if ! grep "GCC ${RELEASE} released." ${x} > /dev/null ; then       
129         cat - ${x} > ${x}.new <<EOF
130 ${LONG_DATE}  Release Manager
131
132         * GCC ${RELEASE} released.
133
134 EOF
135         mv ${x}.new ${x} || \
136             error "Could not update ${x}"
137         (changedir `dirname ${x}` && \
138             ${CVS} ci -m 'Mark ChangeLog' `basename ${x}`) || \
139             error "Could not commit ${x}"
140       fi
141     done
142
143     # Update `gcc/version.c'.
144     for x in gcc/version.c; do 
145       y=`basename ${x}`
146       (changedir `dirname ${SOURCE_DIRECTORY}/${x}` && \
147           sed -e 's|version_string\[\] = \".*\"|version_string\[\] = \"'${RELEASE}'\"|g' < ${y} > ${y}.new && \
148           mv ${y}.new ${y} && \
149           ${CVS} ci -m 'Update version' ${y}) || \
150           error "Could not update ${x}"
151     done
152
153     # Make sure we tag the sources for a final release.
154     TAG="gcc_`echo ${RELEASE} | tr . _`_release"
155
156     rm -rf ${SOURCE_DIRECTORY}
157   fi
158
159   # Tag the sources.
160   if [ -n "${TAG}" ]; then
161     inform "Tagging sources as ${TAG}"
162     ${CVS} rtag -r ${CVSBRANCH} -F ${TAG} gcc || \
163       error "Could not tag sources"
164     EXPORTTAG="-r${TAG}"
165     EXPORTDATE=""
166   else
167     if [ ${CVSBRANCH} != "HEAD" ]; then
168       EXPORTTAG="-r${CVSBRANCH}"
169     else
170       # HEAD is the default branch, no need to specify it.
171       EXPORTTAG=""
172     fi
173     EXPORTDATE="-D`date -u +"%Y-%m-%d %H:%M"` UTC"
174   fi
175
176   # Export the current sources.
177   inform "Retrieving sources (cvs export ${EXPORTTAG} ${EXPORTDATE} gcc)"
178
179   if [ -z "${EXPORTTAG}" ]; then
180     ${CVS} export -d "`basename ${SOURCE_DIRECTORY}`" \
181        "${EXPORTDATE}" gcc || \
182       error "Could not retrieve sources"
183   elif [ -z "${EXPORTDATE}" ]; then
184     ${CVS} export -d "`basename ${SOURCE_DIRECTORY}`" \
185        "${EXPORTTAG}" gcc || \
186       error "Could not retrieve sources"
187   else
188     error "Cannot specify -r and -D at the same time"
189   fi
190
191   # Run gcc_update on them to set up the timestamps nicely, and (re)write
192   # the LAST_UPDATED file containing the CVS tag/date used.
193   changedir "gcc-${RELEASE}"
194   contrib/gcc_update --touch
195   echo "Obtained from CVS: ${EXPORTTAG} ${EXPORTDATE}" > LAST_UPDATED
196
197   # Obtain some documentation files from the wwwdocs module.
198   inform "Retrieving HTML documentation"
199   changedir "${WORKING_DIRECTORY}"
200   for x in bugs faq; do
201     (${CVS} export -r HEAD wwwdocs/htdocs/${x}.html && \
202      cp ${WORKING_DIRECTORY}/wwwdocs/htdocs/${x}.html \
203         ${SOURCE_DIRECTORY}) || \
204       error "Could not retrieve ${x}.html"
205   done
206
207   inform "Generating plain-text documentation from HTML"
208   changedir "${SOURCE_DIRECTORY}"
209   for file in *.html; do
210     newfile=`echo $file | sed -e 's/.html//' | tr "[:lower:]" "[:upper:]"`
211     (${ENV} TERM=vt100 lynx -dump $file \
212        | sed -e "s#file://localhost`/bin/pwd`\(.*\)#http://gcc.gnu.org\1#g" \
213        > $newfile) || \
214      error "Could not generate text-only version of ${file}"
215   done
216
217   # For a prerelease or real release, we need to generate additional
218   # files not present in CVS.
219   changedir "${SOURCE_DIRECTORY}"
220   if [ $SNAPSHOT -ne 1 ]; then
221     # Generate the documentation.
222     inform "Building install docs"
223     SOURCEDIR=${SOURCE_DIRECTORY}/gcc/doc
224     DESTDIR=${SOURCE_DIRECTORY}/INSTALL
225     export SOURCEDIR
226     export DESTDIR
227     ${SOURCE_DIRECTORY}/gcc/doc/install.texi2html
228
229     # Regenerate the NEWS file.
230     contrib/gennews > gcc/NEWS || \
231       error "Could not regenerate NEWS files"
232
233     # Now, we must build the compiler in order to create any generated
234     # files that are supposed to go in the source directory.  This is
235     # also a good sanity check to make sure that the release builds
236     # on at least one platform.
237     inform "Building compiler"
238     OBJECT_DIRECTORY=../objdir
239     contrib/gcc_build -d ${SOURCE_DIRECTORY} -o ${OBJECT_DIRECTORY} build || \
240       error "Could not rebuild GCC"
241
242     # Regenerate the Fotran NEWS and BUGS files.
243     (cd ${OBJECT_DIRECTORY}/gcc && make f77.rebuilt) || \
244       error "Could not regenerate Fortran NEWS and BUGS files"
245   fi
246
247   # Move message catalogs to source directory.
248   mv ../objdir/gcc/po/*.gmo gcc/po/
249
250   # Create a `.brik' file to use for checking the validity of the
251   # release.
252   changedir "${SOURCE_DIRECTORY}"
253   BRIK_FILE=`mktemp /tmp/gcc_release.XXXXXXX`
254   ((find . -type f | sort > $BRIK_FILE) && \
255        brik -Gb -f ${BRIK_FILE} > .brik && \
256        rm ${BRIK_FILE}) || \
257      error "Could not compute brik checksum"
258 }
259
260 # Buid a single tarfile.  The first argument is the name of the name
261 # of the tarfile to build, without any suffixes.  They will be added
262 # automatically.  The rest of the arguments are the files or
263 # directories to include.
264
265 build_tarfile() {
266   # Get the name of the destination tar file.
267   TARFILE="$1.tar.bz2"
268   shift
269
270   # Build the tar file itself.
271   (${TAR} cf - "$@" | ${BZIP2} > ${TARFILE}) || \
272     error "Could not build tarfile"
273   FILE_LIST="${FILE_LIST} ${TARFILE}"
274 }
275
276 # Build the various tar files for the release.
277
278 build_tarfiles() {
279   inform "Building tarfiles"
280
281   changedir "${WORKING_DIRECTORY}"
282
283   # The GNU Coding Standards specify that all files should
284   # world readable.
285   chmod -R a+r ${SOURCE_DIRECTORY}
286   # And that all directories have mode 777.
287   find ${SOURCE_DIRECTORY} -type d -exec chmod 777 {} \;
288  
289   # Build one huge tarfile for the entire distribution.
290   build_tarfile gcc-${RELEASE} `basename ${SOURCE_DIRECTORY}`
291
292   # Now, build one for each of the languages.
293   build_tarfile gcc-ada-${RELEASE} ${ADA_DIRS}
294   build_tarfile gcc-g++-${RELEASE} ${CPLUSPLUS_DIRS}
295   build_tarfile gcc-g77-${RELEASE} ${FORTRAN_DIRS}
296   build_tarfile gcc-java-${RELEASE} ${JAVA_DIRS}
297   build_tarfile gcc-objc-${RELEASE} ${OBJECTIVEC_DIRS}
298   build_tarfile gcc-testsuite-${RELEASE} ${TESTSUITE_DIRS}
299    
300   # The core is everything else.
301   EXCLUDES=""
302   for x in ${ADA_DIRS} ${CPLUSPLUS_DIRS} ${FORTRAN_DIRS} \
303            ${JAVA_DIRS} ${OBJECTIVEC_DIRS} ${TESTSUITE_DIRS}; do
304     EXCLUDES="${EXCLUDES} --exclude $x"
305   done
306   build_tarfile gcc-core-${RELEASE} ${EXCLUDES} \
307     `basename ${SOURCE_DIRECTORY}`
308 }
309
310 # Build .gz files.
311 build_gzip() {
312   for f in ${FILE_LIST}; do
313     target=${f%.bz2}.gz
314     (${BZIP2} -d -c $f | ${GZIP} > ${target}) || error "Could not create ${target}"
315   done
316 }
317
318 # Build diffs against an old release.
319 build_diffs() {
320   old_dir=${1%/*}
321   old_file=${1##*/}
322   old_vers=${old_file%.tar.bz2}
323   old_vers=${old_vers#gcc-}
324   inform "Building diffs against version $old_vers"
325   for f in gcc gcc-ada gcc-g++ gcc-g77 gcc-java gcc-objc gcc-testsuite gcc-core; do
326     old_tar=${old_dir}/${f}-${old_vers}.tar.bz2
327     new_tar=${WORKING_DIRECTORY}/${f}-${RELEASE}.tar.bz2
328     if [ ! -e $old_tar ]; then
329       inform "$old_tar not found; not generating diff file"
330     elif [ ! -e $new_tar ]; then
331       inform "$new_tar not found; not generating diff file"
332     else
333       build_diff $old_tar gcc-${old_vers} $new_tar gcc-${RELEASE} \
334         ${f}-${old_vers}-${RELEASE}.diff.bz2
335     fi
336   done
337 }
338
339 # Build an individual diff.
340 build_diff() {
341   changedir "${WORKING_DIRECTORY}"
342   tmpdir=gccdiff.$$
343   mkdir $tmpdir || error "Could not create directory $tmpdir"
344   changedir $tmpdir
345   (${BZIP2} -d -c $1 | ${TAR} xf - ) || error "Could not unpack $1 for diffs"
346   (${BZIP2} -d -c $3 | ${TAR} xf - ) || error "Could not unpack $3 for diffs"
347   ${DIFF} $2 $4 > ../${5%.bz2}
348   if [ $? -eq 2 ]; then
349     error "Trouble making diffs from $1 to $3"
350   fi
351   ${BZIP2} ../${5%.bz2} || error "Could not generate ../$5"
352   changedir ..
353   rm -rf $tmpdir
354   FILE_LIST="${FILE_LIST} $5"
355 }
356
357 # Upload the files to the FTP server.
358 upload_files() {
359   inform "Uploading files"
360
361   changedir "${WORKING_DIRECTORY}"
362
363   # Make sure the directory exists on the server.
364   if [ $LOCAL -eq 0 ]; then
365     ${SSH} -l ${GCC_USERNAME} ${GCC_HOSTNAME} \
366       mkdir -p "${FTP_PATH}/diffs"
367     UPLOAD_PATH="${GCC_USERNAME}@${GCC_HOSTNAME}:${FTP_PATH}"
368   else
369     mkdir -p "${FTP_PATH}/diffs" \
370       || error "Could not create \`${FTP_PATH}'"
371     UPLOAD_PATH=${FTP_PATH}
372   fi
373
374   # Then copy files to their respective (sub)directories.
375   for x in gcc*.gz gcc*.bz2; do
376     if [ -e ${x} ]; then
377       # Make sure the file will be readable on the server.
378       chmod a+r ${x}
379       # Copy it.
380       case ${x} in
381         *.diff.*)
382           SUBDIR="diffs/";
383           ;;
384         *)
385           SUBDIR="";
386       esac
387       ${SCP} ${x} ${UPLOAD_PATH}/${SUBDIR} \
388         || error "Could not upload ${x}"
389     fi
390   done
391 }
392
393 # Announce a snapshot, both on the web and via mail.
394 announce_snapshot() {
395   inform "Updating links and READMEs on the FTP server"
396   
397   TEXT_DATE=`date --date=$DATE +%B\ %d,\ %Y`
398   cd ~ftp/pub/gcc/snapshots
399   sed -e "s%@DATE@%$DATE%g" \
400     -e "s%@TEXT_DATE@%$TEXT_DATE%g" \
401     -e "s%@LAST_DATE@%$LAST_DATE%g" \
402     -e "s%@BRANCH@%${BRANCH}%g" \
403     -e "s%@RELEASE@%${RELEASE}%g" \
404     -e "s%@EXPORT@%${EXPORTTAG} ${EXPORTDATE}%g" \
405     ~/scripts/snapshot-README > $$
406   mv $$ ${RELEASE}/README
407   sed -e "s%@DATE@%$DATE%g" \
408     -e "s%@TEXT_DATE@%$TEXT_DATE%g" \
409     -e "s%@LAST_DATE@%$LAST_DATE%g" \
410     -e "s%@BRANCH@%${BRANCH}%g" \
411     -e "s%@RELEASE@%${RELEASE}%g" \
412     -e "s%@EXPORT@%${EXPORTTAG} ${EXPORTDATE}%g" \
413     ~/scripts/snapshot-index.html > $$
414   mv $$ ${RELEASE}/index.html
415
416   touch LATEST-IS-${BRANCH}-${DATE}
417   rm -f LATEST-IS-${BRANCH}-${LAST_DATE}
418
419   inform "Sending mail"
420
421   export QMAILHOST=gcc.gnu.org
422   mail -s "gcc-ss-${RELEASE} is now available" gcc@gcc.gnu.org < ~ftp/pub/gcc/snapshots/${RELEASE}/README
423 }
424
425 ########################################################################
426 # Initialization
427 ########################################################################
428
429 # Today's date.
430 DATE=`date "+%Y%m%d"`
431 LONG_DATE=`date "+%Y-%m-%d"`
432
433 # The CVS server containing the GCC repository.
434 CVS_SERVER="gcc.gnu.org"
435 # The path to the repository on that server.
436 CVS_REPOSITORY="/cvs/gcc"
437 # The CVS protocol to use.
438 CVS_PROTOCOL="ext"
439 # The username to use when connecting to the server.
440 CVS_USERNAME="${USER}"
441
442 # The machine to which files will be uploaded.
443 GCC_HOSTNAME="gcc.gnu.org"
444 # The name of the account on the machine to which files are uploaded.
445 GCC_USERNAME="gccadmin"
446 # The directory in which the files will be placed.
447 FTP_PATH="~ftp/pub/gcc"
448
449 # The major number for the release.  For release `3.0.2' this would be 
450 # `3'
451 RELEASE_MAJOR=""
452 # The minor number for the release.  For release `3.0.2' this would be
453 # `0'.
454 RELEASE_MINOR=""
455 # The revision number for the release.  For release `3.0.2' this would
456 # be `2'.
457 RELEASE_REVISION=""
458 # The complete name of the release.
459 RELEASE=""
460
461 # The name of the branch from which the release should be made, in a 
462 # user-friendly form.
463 BRANCH=""
464
465 # The name of the branch from which the release should be made, as used
466 # for our version control system.
467 CVSBRANCH=""
468
469 # The tag to apply to the sources used for the release.
470 TAG=""
471
472 # The old tarballs from which to generate diffs.
473 OLD_TARS=""
474
475 # The directory that will be used to construct the release.  The
476 # release itself will be placed in a subdirectory of this diretory.
477 DESTINATION=${HOME}
478 # The subdirectory.
479 WORKING_DIRECTORY=""
480 # The directory that will contain the GCC sources.
481 SOURCE_DIRECTORY=""
482
483 # The directories that should be part of the various language-specific
484 # tar files.  These are all relative to the top of the source tree.
485 ADA_DIRS="gcc/ada"
486 CPLUSPLUS_DIRS="gcc/cp libstdc++-v3"
487 FORTRAN_DIRS="gcc/f libf2c"
488 JAVA_DIRS="gcc/java libjava libffi fastjar zlib boehm-gc"
489 OBJECTIVEC_DIRS="gcc/objc libobjc"
490 TESTSUITE_DIRS="gcc/testsuite"
491
492 # Non-zero if this is the final release, rather than a prerelease.
493 FINAL=0
494
495 # Non-zero if we are building a snapshot, and don't build gcc or
496 # include generated files.
497 SNAPSHOT=0
498
499 # Non-zero if we are running locally on gcc.gnu.org, and use local CVS
500 # and copy directly to the FTP directory.
501 LOCAL=0
502
503 # Major operation modes.
504 MODE_GZIP=0
505 MODE_DIFFS=0
506 MODE_SOURCES=0
507 MODE_TARFILES=0
508 MODE_UPLOAD=0
509
510 # List of archive files generated; used to create .gz files from .bz2.
511 FILE_LIST=""
512
513 # Programs we use.
514
515 BZIP2="${BZIP2:-bzip2}"
516 CVS="${CVS:-cvs -f -Q -z9}"
517 DIFF="${DIFF:-diff -Nrc3pad}"
518 ENV="${ENV:-env}"
519 GZIP="${GZIP:-gzip --best}"
520 SCP="${SCP:-scp -p}"
521 SSH="${SSH:-ssh}"
522 TAR="${TAR:-tar}"
523
524 ########################################################################
525 # Command Line Processing
526 ########################################################################
527
528 # Parse the options.
529 while getopts "d:fr:u:t:p:s:l" ARG; do
530     case $ARG in
531     d)    DESTINATION="${OPTARG}";;
532     r)    RELEASE="${OPTARG}";;
533     t)    TAG="${OPTARG}";;
534     u)    CVS_USERNAME="${OPTARG}";;
535     f)    FINAL=1;;
536     s)    SNAPSHOT=1
537           BRANCH=${OPTARG%:*}
538           CVSBRANCH=${OPTARG#*:}
539           ;;
540     l)    LOCAL=1
541           SCP=cp
542           FTP_PATH=~ftp/pub/gcc
543           PATH=~:/usr/local/bin:$PATH;;
544     p)    OLD_TARS="${OLD_TARS} ${OPTARG}"
545           if [ -d ${OPTARG} ]; then
546             error "-p argument must name a tarball"
547           fi;;
548     \?)   usage;;
549     esac
550 done
551 shift `expr ${OPTIND} - 1`
552
553 # Handle the major modes.
554 while [ $# -ne 0 ]; do
555     case $1 in
556     diffs)    MODE_DIFFS=1;;
557     gzip)     MODE_GZIP=1;;
558     sources)  MODE_SOURCES=1;;
559     tarfiles) MODE_TARFILES=1;;
560     upload)   MODE_UPLOAD=1;;
561     all)      MODE_SOURCES=1; MODE_TARFILES=1; MODE_DIFFS=1; MODE_UPLOAD=1;
562               if [ $SNAPSHOT -ne 1 ]; then
563                 # Only for releases and pre-releases.
564                 MODE_GZIP=1;
565               fi
566               ;;
567     *)        error "Unknown mode $1";;
568     esac
569     shift
570 done
571
572 # Perform consistency checking.
573 if [ ${LOCAL} -eq 0 ] && [ -z ${CVS_USERNAME} ]; then
574   error "No username specified"
575 fi
576
577 if [ ! -d ${DESTINATION} ]; then
578   error "\`${DESTINATION}' is not a directory"
579 fi
580
581 if [ $SNAPSHOT -eq 0 ]; then
582   if [ -z ${RELEASE} ]; then
583     error "No release number specified"
584   fi
585
586   # Compute the major and minor release numbers.
587   RELEASE_MAJOR=`echo $RELEASE | awk --assign FS=. '{ print $1; }'`
588   RELEASE_MINOR=`echo $RELEASE | awk --assign FS=. '{ print $2; }'`
589   RELEASE_REVISION=`echo $RELEASE | awk --assign FS=. '{ print $3; }'`
590
591   if [ -z "${RELEASE_MAJOR}" ] || [ -z "${RELEASE_MINOR}" ]; then
592     error "Release number \`${RELEASE}' is invalid"
593   fi
594
595   # Compute the full name of the release.
596   if [ -z "${RELEASE_REVISION}" ]; then
597     RELEASE="${RELEASE_MAJOR}.${RELEASE_MINOR}"
598   else
599     RELEASE="${RELEASE_MAJOR}.${RELEASE_MINOR}.${RELEASE_REVISION}"
600   fi
601
602   # Compute the name of the branch, which is based solely on the major
603   # and minor release numbers.
604   CVSBRANCH="gcc-${RELEASE_MAJOR}_${RELEASE_MINOR}-branch"
605
606   # If this is not a final release, set various parameters acordingly.
607   if [ ${FINAL} -ne 1 ]; then
608     RELEASE="${RELEASE}-${DATE}"
609     FTP_PATH="${FTP_PATH}/prerelease-${RELEASE}/"
610   else
611     FTP_PATH="${FTP_PATH}/releases/gcc-${RELEASE}/"
612   fi
613 else
614   RELEASE=${BRANCH}-${DATE}
615   FTP_PATH="${FTP_PATH}/snapshots/${RELEASE}"
616   if [ ${CVSBRANCH} != "HEAD" ]; then
617     TAG=gcc-ss-`echo ${RELEASE} | tr '.' '_'`
618   fi
619
620   # Building locally on gcc.gnu.org, we know what the last snapshot date
621   # was.
622   if [ $MODE_DIFFS -ne 0 ] && [ $LOCAL -ne 0 ]; then
623     LAST_DATE=`cat ~/.snapshot_date-${BRANCH}`
624     LAST_DIR=~ftp/pub/gcc/snapshots/${BRANCH}-${LAST_DATE}
625     OLD_TARS=${LAST_DIR}/gcc-${BRANCH}-${LAST_DATE}.tar.bz2
626   fi
627 fi
628
629 # Compute the name of the WORKING_DIRECTORY and the SOURCE_DIRECTORY.
630 WORKING_DIRECTORY="${DESTINATION}/gcc-${RELEASE}"
631 SOURCE_DIRECTORY="${WORKING_DIRECTORY}/gcc-${RELEASE}"
632
633 # Recompute the names of all the language-specific directories,
634 # relative to the WORKING_DIRECTORY.
635 ADA_DIRS=`adjust_dirs ${ADA_DIRS}`
636 CPLUSPLUS_DIRS=`adjust_dirs ${CPLUSPLUS_DIRS}`
637 FORTRAN_DIRS=`adjust_dirs ${FORTRAN_DIRS}`
638 JAVA_DIRS=`adjust_dirs ${JAVA_DIRS}`
639 OBJECTIVEC_DIRS=`adjust_dirs ${OBJECTIVEC_DIRS}`
640 TESTSUITE_DIRS=`adjust_dirs ${TESTSUITE_DIRS}`
641
642 # Set up CVSROOT.
643 if [ $LOCAL -eq 0 ]; then
644     CVSROOT=":${CVS_PROTOCOL}:${CVS_USERNAME}@"
645     CVSROOT="${CVSROOT}${CVS_SERVER}:${CVS_REPOSITORY}"
646 else
647     CVSROOT="${CVS_REPOSITORY}"
648 fi
649 export CVSROOT
650
651 ########################################################################
652 # Main Program
653 ########################################################################
654
655 # Set the timezone to UTC
656 TZ="UTC0"
657 export TZ
658
659 # Build the source directory.
660
661 if [ $MODE_SOURCES -ne 0 ]; then
662   build_sources
663 fi
664
665 # Build the tar files.
666
667 if [ $MODE_TARFILES -ne 0 ]; then
668   build_tarfiles
669 fi
670
671 # Build diffs
672
673 if [ $MODE_DIFFS -ne 0 ]; then
674   # Possibly build diffs.
675   if [ -n "$OLD_TARS" ]; then
676     for old_tar in $OLD_TARS; do
677       build_diffs $old_tar
678     done
679   fi
680 fi
681
682 # Build gzip files
683 if [ $MODE_GZIP -ne 0 ]; then
684   build_gzip
685 fi
686
687 # Upload them to the FTP server.
688
689 if [ $MODE_UPLOAD -ne 0 ]; then
690   upload_files
691
692   # For snapshots, make some further updates.
693   if [ $SNAPSHOT -ne 0 ] && [ $LOCAL -ne 0 ]; then
694     announce_snapshot
695
696     # Update snapshot date file.
697     changedir ~
698     echo $DATE > .snapshot_date-${BRANCH}
699
700     # Remove working directory
701     rm -rf ${WORKING_DIRECTORY}
702   fi
703 fi